/*!
  \file Draw_Circle.c
  \author Mario Palomo <mpalomo@ihman.com>
  \author Jose M. de la Huerga Fernndez
  \author Pepe Gonzlez Mora
  \date 05-2002

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free Foundation,
  Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
/*
 Abajo  derecha
 Arriba derecha
 Abajo  izquierda
 Arriba izquierda
 
 
*/

#ifdef SDL_DRAW_CLIP

#define SDL_DRAW_PUTPIXEL_BPP(A, B, C)  \
if(rangeAlfa <= 6 && 6 <= rangeBeta && rpx >= lx && dpy > uy && rpx < rx && dpy < dy)	\
*(A(B(Uint8*)super->pixels + dpy*super->pitch +               \
                                          rpx*SDL_DRAW_BPP)) = C; \
if(rangeAlfa <= 1 && 1 <= rangeBeta && rpx >= lx && upy > uy && rpx < rx && upy < dy)	\
*(A(B(Uint8*)super->pixels + upy*super->pitch +               \
                                          rpx*SDL_DRAW_BPP)) = C; \
if(rangeAlfa <= 5 && 5 <= rangeBeta && lpx >= lx && dpy > uy && lpx < rx && dpy < dy)	\
*(A(B(Uint8*)super->pixels + dpy*super->pitch +               \
                                          lpx*SDL_DRAW_BPP)) = C; \
if(rangeAlfa <= 2 && 2 <= rangeBeta && lpx >= lx && upy > uy && lpx < rx && upy < dy)	\
*(A(B(Uint8*)super->pixels + upy*super->pitch +               \
                                          lpx*SDL_DRAW_BPP)) = C; \
if(rangeAlfa <= 7 && 7 <= rangeBeta && lxy >= lx && lyx > uy && lxy < rx && lyx < dy)	\
*(A(B(Uint8*)super->pixels + lyx*super->pitch +               \
                                          lxy*SDL_DRAW_BPP)) = C; \
if(rangeAlfa <= 0 && 0 <= rangeBeta && lxy >= lx && ryx > uy && lxy < rx && ryx < dy)	\
*(A(B(Uint8*)super->pixels + ryx*super->pitch +               \
                                          lxy*SDL_DRAW_BPP)) = C; \
if(rangeAlfa <= 4 && 4 <= rangeBeta && rxy >= lx && lyx > uy && rxy < rx && ryx < dy)	\
*(A(B(Uint8*)super->pixels + lyx*super->pitch +               \
                                          rxy*SDL_DRAW_BPP)) = C; \
if(rangeAlfa <= 3 && 3 <= rangeBeta && rxy >= lx && ryx > uy && rxy < rx && ryx < dy)	\
*(A(B(Uint8*)super->pixels + ryx*super->pitch +               \
                                          rxy*SDL_DRAW_BPP)) = C;
#else

#define SDL_DRAW_PUTPIXEL_BPP(A, B, C)  \
*(A(B(Uint8*)super->pixels + (y0+y)*super->pitch +               \
                                          (x0+x)*SDL_DRAW_BPP)) = C; \
*(A(B(Uint8*)super->pixels + (y0-y)*super->pitch +               \
                                          (x0+x)*SDL_DRAW_BPP)) = C; \
*(A(B(Uint8*)super->pixels + (y0+y)*super->pitch +               \
                                          (x0-x)*SDL_DRAW_BPP)) = C; \
*(A(B(Uint8*)super->pixels + (y0-y)*super->pitch +               \
                                          (x0-x)*SDL_DRAW_BPP)) = C; \
*(A(B(Uint8*)super->pixels + (y0+x)*super->pitch +               \
                                          (x0+y)*SDL_DRAW_BPP)) = C; \
*(A(B(Uint8*)super->pixels + (y0-x)*super->pitch +               \
                                          (x0+y)*SDL_DRAW_BPP)) = C; \
*(A(B(Uint8*)super->pixels + (y0+x)*super->pitch +               \
                                          (x0-y)*SDL_DRAW_BPP)) = C; \
*(A(B(Uint8*)super->pixels + (y0-x)*super->pitch +               \
                                          (x0-y)*SDL_DRAW_BPP)) = C;
#endif

#if SDL_DRAW_BPP == 1
#define SDL_DRAW_PUTPIXEL SDL_DRAW_PUTPIXEL_BPP(0+,0+,color)

#elif SDL_DRAW_BPP == 2
#define SDL_DRAW_PUTPIXEL SDL_DRAW_PUTPIXEL_BPP((Uint16*),0+,color)

#elif SDL_DRAW_BPP == 3
#define SDL_DRAW_PUTPIXEL \
  SDL_DRAW_PUTPIXEL_BPP(0+,1+,colorbyte1)   \
  if (SDL_BYTEORDER == SDL_BIG_ENDIAN) {  \
    SDL_DRAW_PUTPIXEL_BPP(0+,0+,colorbyte2)   \
    SDL_DRAW_PUTPIXEL_BPP(0+,2+,colorbyte0) \
  }else{                                  \
    SDL_DRAW_PUTPIXEL_BPP(0+,0+,colorbyte0)   \
    SDL_DRAW_PUTPIXEL_BPP(0+,2+,colorbyte2) \
  }

#elif SDL_DRAW_BPP == 4
#define SDL_DRAW_PUTPIXEL SDL_DRAW_PUTPIXEL_BPP((Uint32*),0+,color)

#endif /*SDL_DRAW_BPP*/


void SDL_DRAWFUNCTION(SDL_Surface *super,
                      Sint16 x0, Sint16 y0, Uint16 r,
                      Uint32 color)
{
#if SDL_DRAW_BPP == 3
  Uint8 colorbyte0 = (Uint8) (color & 0xff);
  Uint8 colorbyte1 = (Uint8) ((color >> 8) & 0xff);
  Uint8 colorbyte2 = (Uint8) ((color >> 16) & 0xff);
#endif

  Sint16 x = 0;
  Sint16 y = r-1;     /*radius zero == draw nothing*/
  Sint16 d = 3 - 2*r;
  Sint16 diagonalInc = 10 - 4*r;
  Sint16 rightInc = 6;

  /*Esto sobra*/
  Sint16 alfa = 1;
  Sint16 beta = 46;
  Sint16 itmp;
  Sint16 rangeAlfa;
  Sint16 rangeBeta;

#ifdef SDL_DRAW_CLIP  
  Sint16 lpx, rpx, upy, dpy, lxy, lyx, rxy, ryx; 
  Sint16 lx,rx,uy,dy;

  lx = super->clip_rect.x;
  rx = super->clip_rect.x + super->clip_rect.w - 1;
  uy = super->clip_rect.y;
  dy = super->clip_rect.y + super->clip_rect.h - 1;
#endif
 
  /* Lock surface */
  if (SDL_MUSTLOCK(super)) {
    if (SDL_LockSurface(super) < 0)  { return; }
  }

  /* Minimal conditions */
  if (alfa == beta) { return; }

  /* Angle in order */
  if (alfa > beta) {
	  itmp=alfa;
	  alfa=beta;
	  beta=itmp;
  }

  rangeAlfa = 360 / alfa;
  rangeBeta = 360 / beta;
  
  printf("------ %d %d ------",rangeAlfa, rangeBeta); 

  while (x <= y) {

#ifdef SDL_DRAW_CLIP
	lpx = x0-x;
	rpx = x0+x;
	upy = y0-y;
	dpy = y0+y;

	lyx = y0+x;
	lxy = x0+y;
	ryx = y0-x;
	rxy = x0-y;
#endif 


    SDL_DRAW_PUTPIXEL

    if (d >=  0) {
      d += diagonalInc;
      diagonalInc += 8;
      y -= 1;
    } else {
      d += rightInc;
      diagonalInc += 4;
    }
    rightInc += 4;
    x += 1;
  }

  /* Unlock surface */
  if (SDL_MUSTLOCK(super))  { SDL_UnlockSurface(super); }
  
}/*Draw_Circle*/


#undef SDL_DRAW_PUTPIXEL
#undef SDL_DRAW_PUTPIXEL_BPP

