/*!
  \file Draw_Polygon.c
  \author Mario Palomo <mpalomo@ihman.com>
  \author Jose M. de la Huerga Fernndez
  \author Pepe Gonzlez Mora
  \date 05-2002

*/
/*
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free Foundation,
  Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

/* Based in Draw_Line */
void Draw_Polygon(SDL_Surface *super, Sint16 *vx, Sint16 *vy, int n, Uint32 color)          
{
    int i;
    Sint16 *x1, *y1, *x2, *y2;

    if (n < 3) { return;  }

    /** Pointer setup  */
    x1 = x2 = vx;
    y1 = y2 = vy;
    ++x2;
    ++y2;

    /*  Draw  */
    for (i = 1; i < n; i++) {
          Draw_Line(super, *x1, *y1, *x2, *y2, color);
          x1 = x2;
          y1 = y2;
          ++x2;
          ++y2;
    }
    Draw_Line(super, *x1, *y1, *vx, *vy, color);

}/*Draw_Polygon*/



